#ifndef _MATH_H
#define _MATH_H

#include "stddef.h"
#include "stdarg.h"

int abs(int _X);
long labs(long _X);

double acos(double _X);
double asin(double _X);
double atan(double _X);
double atan2(double _Y,double _X);

double cos(double _X);
double cosh(double _X);
double exp(double _X);
double expm1(double _X);
double fabs(double _X);
double fmod(double _X,double _Y);
double log(double _X);
double log10(double _X);
double pow(double _X,double _Y);
double sin(double _X);
double sinh(double _X);
double tan(double _X);
double tanh(double _X);
double sqrt(double _X);

double atof(const char *_String);

double ceil(double _X);
double floor(double _X);
double frexp(double _X,int *_Y);
double ldexp(double _X,int _Y);

double modf(double _X,double *_Y);

float frexpf(float _X,int *_Y);
float ldexpf(float _X,int _Y);
long double ldexpl(long double _X,int _Y);
float acosf(float _X);
float asinf(float _X);
float atanf(float _X);
float atan2f(float _X,float _Y);
float cosf(float _X);
float sinf(float _X);
float tanf(float _X);
float coshf(float _X);
float sinhf(float _X);
float tanhf(float _X);
float expf(float _X);
float expm1f(float _X);
float logf(float _X);
float log10f(float _X);
float modff(float _X,float *_Y);
float powf(float _X,float _Y);
float sqrtf(float _X);
float ceilf(float _X);
float floorf(float _X);
float fmodf(float _X,float _Y);

#define fabsf (float)fabs
#define ldexpf(x, expn) (float)ldexp(x, expn)
#define frexpf(x, y) (float)frexp(x, y)

#endif
