
void ld34_init_sc02()
{
	ld34_game_destroy();

	game.img_count = 1;
	img_load_float(&game.img[0], "dataset/sc02/bg.png");

	game.vecto_count = 2;
	h_load(&game.vecto[0], "dataset/sc02/char01.hou_raw");
	h_load(&game.vecto[1], "dataset/sc02/char01_out.hou_raw");

	ld34_scale_vecto();

	game.step = 0;
	_t = 0;

	sound2();
}

void ld34_update_sc02(struct m_image *dest, double t)
{
	int ti15 = t * 15;

	m_image_copy(dest, &game.img[0]);

	switch (game.step) {
	case 0:
		{
			if (ti15 < 70) {
				h_frame_draw(dest, game.vecto[0].layer[0].frame);
			}
			else {
				int i = M_MIN(ti15 - 70, game.vecto[0].layer[0].frame_count - 1);
				h_frame_draw(dest, game.vecto[0].layer[0].frame + i);
			}

			if (t < 2) {

				int r = (1 - (t / 1.5)) * 16;

				m_image_gaussian_blur(dest, dest, r, r);

				float v = 1 - M_MIN(1, t);
				v = powf(v, 2.0);
				m_image_add1(dest, dest, v);

				image_effect_rand(dest, powf(2 - t, 2) * 10000);
			}

			if (ti15 > 10 && ti15 < 140)
				m_font_draw(dest, &ld34_font, "...but teleportation is the worst", (ti15 - 10), 12, 182, ld34_color_pl);

			if (ti15 > 110)
				m_font_draw(dest, &ld34_font, "welcome to\nthe earth", (ti15 - 110), 205, 80, ld34_color_ch);
			else if (ti15 > 80)
				m_font_draw(dest, &ld34_font, "greetings", (ti15 - 80), 205, 80, ld34_color_ch);

			if (ti15 > 140) {
				m_image_draw(dest, &ld34_ui[0], 10, 180);
				m_font_draw(dest, &ld34_font, "talk", -1, 30, 182, ld34_color_pl);

				m_image_draw(dest, &ld34_ui[1], 80, 180);
				m_font_draw(dest, &ld34_font, "go back home", -1, 100, 182, ld34_color_pl);

				if (ctoy_key_press('R')) {
					game.scene = 2;
					ld34_init_sc03();
				}

				if (ctoy_key_press('E')) {
					game.step++;
					_t = 0;
				}
			}
		}
		break;
	case 1:
		{
			h_frame_draw(dest, game.vecto[0].layer[0].frame);

			m_font_draw(dest, &ld34_font, "greetings", ti15, 12, 182, ld34_color_pl);

			m_image_draw(dest, &ld34_ui[1], 260, 180);
			m_font_draw(dest, &ld34_font, "...", -1, 280, 182, ld34_color_pl);

			if (ctoy_key_press('R')) {
				game.step++;
				_t = 0;
			}
		}
		break;
	case 2:
		{
			if (ti15 > 30) {
				int i = M_MIN(ti15-30, game.vecto[0].layer[0].frame_count - 1);;
				h_frame_draw(dest, game.vecto[0].layer[0].frame + i);

				m_font_draw(dest, &ld34_font, "yes, you are here\nto replace Dr.Smith\n", ti15 - 30, 160, 75, ld34_color_ch);
			}
			else {
				h_frame_draw(dest, game.vecto[0].layer[0].frame);
			}

			if (ti15 > 70) {
				m_image_draw(dest, &ld34_ui[0], 10, 180);
				m_font_draw(dest, &ld34_font, "Dr.Smith", -1, 30, 182, ld34_color_pl);

				m_image_draw(dest, &ld34_ui[1], 110, 180);
				m_font_draw(dest, &ld34_font, "the job", -1, 130, 182, ld34_color_pl);
			}
			else {
				m_font_draw(dest, &ld34_font, "I was sent here by ludumcorp", ti15, 12, 182, ld34_color_pl);
			}

			if (ctoy_key_press('E')) {
				game.step = 3;
				_t = 0;
			}
			else if (ctoy_key_press('R')) {
				game.step = 4;
				_t = 0;
			}
		}
		break;
	case 3:
		{
			if (ti15 > 30) {
				int i = M_MIN(ti15-30, game.vecto[0].layer[0].frame_count - 1);;
				h_frame_draw(dest, game.vecto[0].layer[0].frame + i);

				m_font_draw(dest, &ld34_font, "it was a terrible\naccident\neaten alive by\na giant cockroach\n", ti15 - 30, 165, 60, ld34_color_ch);
			}
			else {
				h_frame_draw(dest, game.vecto[0].layer[0].frame);
			}

			if (ti15 > 80) {
				if (game.smell) {
					m_image_draw(dest, &ld34_ui[0], 10, 180);
					m_font_draw(dest, &ld34_font, "follow him", -1, 30, 182, ld34_color_pl);
				}
				else {
					m_image_draw(dest, &ld34_ui[0], 10, 180);
					m_font_draw(dest, &ld34_font, "the job", -1, 30, 182, ld34_color_pl);

					m_image_draw(dest, &ld34_ui[1], 110, 180);
					m_font_draw(dest, &ld34_font, "go back home", -1, 130, 182, ld34_color_pl);
				}
			}
			else {
				m_font_draw(dest, &ld34_font, "what happened to him ?", ti15, 12, 182, ld34_color_pl);
			}

			if (game.smell) {
				if (ctoy_key_press('E')) {
					game.step = 7;
					_t = 0;
				}
			}
			else {
				if (ctoy_key_press('E')) {
					game.step = 4;
					_t = 0;
				}
				else if (ctoy_key_press('R')) {
					game.scene = 2;
					ld34_init_sc03();
				}
			}
		}
		break;

	case 4:
		{
			if (ti15 > 30) {
				int i = M_MIN(ti15-30, game.vecto[0].layer[0].frame_count - 1);;
				h_frame_draw(dest, game.vecto[0].layer[0].frame + i);

				m_font_draw(dest, &ld34_font, "what a dump, right?", ti15 - 30, 160, 80, ld34_color_ch);
			}
			else {
				h_frame_draw(dest, game.vecto[0].layer[0].frame);
			}

			if (ti15 > 50) {
				m_image_draw(dest, &ld34_ui[0], 10, 180);
				m_font_draw(dest, &ld34_font, "Dr.Smith", -1, 30, 182, ld34_color_pl);

				m_image_draw(dest, &ld34_ui[1], 110, 180);
				m_font_draw(dest, &ld34_font, "the job seriously", -1, 130, 182, ld34_color_pl);
			}
			else {
				m_font_draw(dest, &ld34_font, "what am I doing here ?", ti15, 12, 182, ld34_color_pl);
			}

			if (ctoy_key_press('E')) {
				game.step = 3;
				_t = 0;
			}
			else if (ctoy_key_press('R')) {
				game.step = 5;
				_t = 0;
			}
		}
		break;

	case 5:
		{
			if (ti15 > 30) {
				int i = M_MIN(ti15-30, game.vecto[0].layer[0].frame_count - 1);;
				h_frame_draw(dest, game.vecto[0].layer[0].frame + i);

				m_font_draw(dest, &ld34_font, "nobody told you about\nthe big dig for\nhuman history ?", ti15 - 30, 130, 70, ld34_color_ch);
			}
			else {
				h_frame_draw(dest, game.vecto[0].layer[0].frame);
			}

			if (ti15 > 70) {
				m_image_draw(dest, &ld34_ui[0], 10, 180);
				m_font_draw(dest, &ld34_font, "Dr.Smith", -1, 30, 182, ld34_color_pl);

				m_image_draw(dest, &ld34_ui[1], 110, 180);
				m_font_draw(dest, &ld34_font, "look around", -1, 130, 182, ld34_color_pl);
			}
			else {
				m_font_draw(dest, &ld34_font, "no seriously, what am I doing here ?", ti15, 12, 182, ld34_color_pl);
			}

			if (ctoy_key_press('E')) {
				game.step = 3;
				_t = 0;
			}
			else if (ctoy_key_press('R')) {
				game.step = 6;
				_t = 0;
			}
		}
		break;

	case 6:
		{
			if (ti15 > 50) {
				int i = M_MIN(ti15-30, game.vecto[0].layer[0].frame_count - 1);;
				h_frame_draw(dest, game.vecto[0].layer[0].frame + i);

				m_font_draw(dest, &ld34_font, "I have to go back.\nI'm Major Morgan,\n by the way\n", ti15 - 50, 140, 70, ld34_color_ch);
			}
			else {
				h_frame_draw(dest, game.vecto[0].layer[0].frame);
			}

			if (ti15 > 70) {
				m_image_draw(dest, &ld34_ui[0], 10, 180);
				m_font_draw(dest, &ld34_font, "Dr.Smith", -1, 30, 182, ld34_color_pl);

				m_image_draw(dest, &ld34_ui[1], 110, 180);
				m_font_draw(dest, &ld34_font, "follow him", -1, 130, 182, ld34_color_pl);
			}
			else {
				m_font_draw(dest, &ld34_font, "it smells of dust and iron...", ti15, 12, 182, ld34_color_pl);
			}

			if (ctoy_key_press('E')) {
				game.step = 3;
				_t = 0;
			}
			else if (ctoy_key_press('R')) {
				game.step = 7;
				_t = 0;
			}

			game.smell = 1;
		}
		break;

	case 7:
		{
			if (ti15 < game.vecto[1].layer[0].frame_count)
				h_frame_draw(dest, game.vecto[1].layer[0].frame + ti15);
			
			if (t > 2.0) {
				float v = (t - 2.0) * 1.5;
				v = -M_MIN(1, v);
				m_image_add1(dest, dest, v);
			}

			if (t > 3.5) {
				game.scene = 3;
				ld34_init_sc04();
			}
		}
		break;
	}
}
