
#define LD34_SC03_STAR_MAX 128
float3 ld34_sc03_stars[LD34_SC03_STAR_MAX];


void ld34_init_sc03()
{
	int i;

	ld34_game_destroy();

	for (i = 0; i < LD34_SC03_STAR_MAX; i++) {
		ld34_sc03_stars[i].x = m_randf();
		ld34_sc03_stars[i].y = m_randf();
		ld34_sc03_stars[i].z = m_randf() * 4;
	}

	sound1();
	_t = 0;
}

void ld34_update_sc03(struct m_image *dest, double t)
{
	static double prevt = 0;
	int ti15 = t * 15;
	int i;

	if (prevt > 0) {
		double elapst = t - prevt;
		for (i = 0; i < LD34_SC03_STAR_MAX; i++) {
			ld34_sc03_stars[i].z -= elapst;
			if (ld34_sc03_stars[i].z < 0.1) {
				ld34_sc03_stars[i].x = m_randf();
				ld34_sc03_stars[i].y = m_randf();
				ld34_sc03_stars[i].z = m_randf() * 4;
			}
		}
	}

	memset(dest->data, 0, sizeof(float) * dest->size);

	for (i = 0; i < LD34_SC03_STAR_MAX; i++) {
		float x = (ld34_sc03_stars[i].x - 0.5f) / ld34_sc03_stars[i].z;
		float y = (ld34_sc03_stars[i].y - 0.5f) / ld34_sc03_stars[i].z;
		int ix = (x + 0.5f) * dest->width;
		int iy = (y + 0.5f) * dest->height;
		if (ix >= 0 && ix < dest->width && iy >= 0 && iy < dest->height) {
			float *pixel = (float *)dest->data + (iy * dest->width + ix) * dest->comp;
			pixel[0] = 1;
			pixel[1] = 1;
			pixel[2] = 1;
		}
	}

	if (ti15 > 0 && ti15 < 150)
		m_font_draw(dest, &ld34_font, "your estimated arrival time is\none hour, one hundred and two years\nfrom now", ti15, 10, 7, ld34_color_pl);

	if (ti15 > 150)
		m_font_draw(dest, &ld34_font, "please enjoy your flight with\ngameover-airline", (ti15 - 150), 10, 7, ld34_color_pl);
	
	if (ti15 > 180) {
		m_image_draw(dest, &ld34_ui[0], 10, 180);
		m_font_draw(dest, &ld34_font, "restart", -1, 30, 182, ld34_color_pl);

		if (ctoy_key_pressed('E')) {
			game.scene = 0;
			ld34_init_intro();
		}
	}

	prevt = t;
}
