

void ld34_init_sc05()
{
	ld34_game_destroy();

	game.img_count = 1;
	img_load_float(&game.img[0], "dataset/sc05/bg.png");

	game.vecto_count = 2;
	h_load(&game.vecto[0], "dataset/sc05/sc05.hou_raw");
	h_load(&game.vecto[1], "dataset/sc05/key.hou_raw");

	float2 transl = {-0.1, -0.1};
	float2 scale = {LD34_WIDTH*1.25, LD34_HEIGHT*1.25};
	h_translate(&game.vecto[0], &transl);
	h_scale(&game.vecto[0], &scale);

	scale.x = LD34_WIDTH;
	scale.y = LD34_HEIGHT;
	h_scale(&game.vecto[1], &scale);

	game.whisper = 1;
	_t = 0;

	//game.step = 7;
}

void ld34_update_sc05(struct m_image *dest, double t)
{
	int ti15 = t * 15;
	int r = M_MAX(0, 1 - t) * 8;

	memset(dest->data, 0, sizeof(float) * dest->size);
	//m_image_copy(dest, &game.img[0]);

	switch (game.step) {
		case 0:
		{
			m_font_draw(dest, &ld34_font, "over here", ti15, 50, 40, ld34_color_ch_dark);
			if (ti15 > 15) {
				game.step++;
				_t = 0;
			}
		}
		break;
		case 1:
		{
			int i = M_MIN(ti15, game.vecto[0].layer[0].frame_count - 1);
			h_frame_draw(dest, game.vecto[0].layer[0].frame + i);

			if (r > 0)
				m_image_gaussian_blur(dest, dest, r, r);

			if (ti15 > 15)
				m_font_draw(dest, &ld34_font, "There is something\nyou should know\nabout Dr.Smith", (ti15 - 15), 40, 30, ld34_color_ch_dark);
			else
				m_font_draw(dest, &ld34_font, "over here", -1, 50, 40, ld34_color_ch_dark);

			if (ti15 > 60) {
				m_image_draw(dest, &ld34_ui[0], 10, 180);
				m_font_draw(dest, &ld34_font, "go on", -1, 30, 182, ld34_color_pl);

				m_image_draw(dest, &ld34_ui[1], 100, 180);
				m_font_draw(dest, &ld34_font, "leave", -1, 120, 182, ld34_color_pl);
			}

			if (ctoy_key_press('E')) {
				game.step++;
				_t = 0;
			}
			else if (ctoy_key_press('R')) {
				game.scene = 3;
				ld34_init_sc04();
			}
		}
		break;
		case 2:
		{
			int i = game.vecto[0].layer[0].frame_count - 1;
			h_frame_draw(dest, game.vecto[0].layer[0].frame + i);

			m_font_draw(dest, &ld34_font, "something\n is wrong.\n\nit wasn't\n an accident",
				ti15, 50, 40, ld34_color_ch_dark);

			if (ti15 > 40) {
				m_image_draw(dest, &ld34_ui[0], 10, 180);
				m_font_draw(dest, &ld34_font, "explain", -1, 30, 182, ld34_color_pl);

				m_image_draw(dest, &ld34_ui[1], 110, 180);
				m_font_draw(dest, &ld34_font, "cockroach ?", -1, 130, 182, ld34_color_pl);
			}

			if (ctoy_key_press('E')) {
				game.step = 3;
				_t = 0;
			}
			else if (ctoy_key_press('R')) {
				game.step = 4;
				_t = 0;
			}
		}
		break;
		case 3:
		{
			int i = game.vecto[0].layer[0].frame_count - 1;
			h_frame_draw(dest, game.vecto[0].layer[0].frame + i);

			if (ti15 > 20)
			m_font_draw(dest, &ld34_font, "he was obsessed with\nsomething secret\n\n\"growth, growth\"\nhe kept mumbling\n\n \"that's it!\"", 
				(ti15 - 20), 30, 20, ld34_color_ch_dark);

			if (ti15 > 120) {
				m_image_draw(dest, &ld34_ui[0], 10, 180);
				m_font_draw(dest, &ld34_font, "cockroach ?", -1, 30, 182, ld34_color_pl);

				m_image_draw(dest, &ld34_ui[1], 130, 180);
				m_font_draw(dest, &ld34_font, "who are you", -1, 150, 182, ld34_color_pl);
			}
			else {
				if (game.thrust)
					m_font_draw(dest, &ld34_font, "what do you know ?", ti15, 12, 182, ld34_color_pl);
				else
					m_font_draw(dest, &ld34_font, "what do you mean ?", ti15, 12, 182, ld34_color_pl);
			}

			if (ctoy_key_press('E')) {
				game.step = 4;
				_t = 0;
			}
			else if (ctoy_key_press('R')) {
				game.step = 5;
				_t = 0;
			}
		}
		break;
		case 4:
		{
			int i = game.vecto[0].layer[0].frame_count - 1;
			h_frame_draw(dest, game.vecto[0].layer[0].frame + i);

			if (ti15 > 20)
			m_font_draw(dest, &ld34_font, "don't trust him,\nthat's what Dr.Smith\n said", 
				(ti15 - 20), 30, 20, ld34_color_ch_dark);

			if (ti15 > 80) {
				m_image_draw(dest, &ld34_ui[0], 10, 180);
				m_font_draw(dest, &ld34_font, "Dr.Smith", -1, 30, 182, ld34_color_pl);

				m_image_draw(dest, &ld34_ui[1], 130, 180);
				m_font_draw(dest, &ld34_font, "leave", -1, 150, 182, ld34_color_pl);
			}
			else {
				m_font_draw(dest, &ld34_font, "Major Morgan told me...", ti15, 12, 182, ld34_color_pl);
			}

			if (ctoy_key_press('E')) {
				game.step = 3;
				_t = 0;
			}
			else if (ctoy_key_press('R')) {
				game.scene = 3;
				ld34_init_sc04();
			}

			game.thrust = 1;
		}
		break;
		case 5:
		{
			int i = game.vecto[0].layer[0].frame_count - 1;
			h_frame_draw(dest, game.vecto[0].layer[0].frame + i);

			if (ti15 > 30)
			m_font_draw(dest, &ld34_font, "who do you think\nis digging ?", 
				(ti15 - 30), 30, 20, ld34_color_ch_dark);

			if (ti15 > 60) {
				m_image_draw(dest, &ld34_ui[0], 10, 180);
				m_font_draw(dest, &ld34_font, "robots ?", -1, 30, 182, ld34_color_pl);

				m_image_draw(dest, &ld34_ui[1], 110, 180);
				m_font_draw(dest, &ld34_font, "mecanoids ?", -1, 130, 182, ld34_color_pl);
			}
			else {
				m_font_draw(dest, &ld34_font, "who are you, you triple-eye?", ti15, 12, 182, ld34_color_pl);
			}

			if (ctoy_key_press('E')) {
				game.step = 6;
				_t = 0;
			}
			else if (ctoy_key_press('R')) {
				game.step = 6;
				_t = 0;
			}
		}
		break;
		case 6:
		{
			int i = game.vecto[0].layer[0].frame_count - 1;
			h_frame_draw(dest, game.vecto[0].layer[0].frame + i);

			m_font_draw(dest, &ld34_font, "hahahaha", 
				ti15, 60, 40, ld34_color_ch_dark);

			if (ti15 > 10) {
				m_image_draw(dest, &ld34_ui[0], 10, 180);
				m_font_draw(dest, &ld34_font, "leave", -1, 30, 182, ld34_color_pl);
			}

			if (ctoy_key_press('E')) {
				if (game.key) {
					game.scene = 3;
					ld34_init_sc04();
				}
				else {
					game.step = 7;
					_t = 0;
				}
			}
		}
		break;
		case 7:
		{
			if (ti15 > 40) {
				int i = M_MIN(ti15 - 40, game.vecto[1].layer[0].frame_count - 1);
				h_frame_draw(dest, game.vecto[1].layer[0].frame + i);
			} else {
				int i = game.vecto[0].layer[0].frame_count - 1;
				h_frame_draw(dest, game.vecto[0].layer[0].frame + i);
			}

			m_font_draw(dest, &ld34_font, "wait, he gave me\nthis object:\n\nI don't know what\nit is and I'm scared\nto keep it\n\n please take it", 
				ti15, 20, 20, ld34_color_ch_dark);

			if (ti15 > 80) {
				m_image_draw(dest, &ld34_ui[0], 10, 180);
				m_font_draw(dest, &ld34_font, "ok", -1, 30, 182, ld34_color_pl);

				m_image_draw(dest, &ld34_ui[1], 80, 180);
				m_font_draw(dest, &ld34_font, "no thanks", -1, 100, 182, ld34_color_pl);
			}

			if (ctoy_key_press('E')) {
				game.scene = 3;
				ld34_init_sc04();
				game.key = 1;
			}
			else if (ctoy_key_press('R')) {
				game.scene = 3;
				ld34_init_sc04();
			}
		}
		break;
	}
}
