#include <ctoy.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <assert.h>

#include "play/sound_test.c"
#include "util/math.c"
#include "util/img_utils.c"
#include "util/font.c"
#include "util/gl_image.c"
#include "vectorial/vectorial.c"

#include "ld34.c"


struct m_image image = M_IMAGE_IDENTITY();
struct h_scene scene = H_IDENTITY();

#define CRT


void ctoy_begin(void)
{
	ld34_init();

	ctoy_window_size(320*3, 200*3);
	m_image_create(&image, M_FLOAT, 320, 200, 3);
	memset(image.data, 0, sizeof(float) * image.size);
		
	// loading
	{
		float color[3] = {1, 1, 1};
		m_font_draw(&image, &ld34_font, "loading...", -1, (320 - (10*7))/2, (200 - (1*10))/2, color);
		glUseProgram(0);
		ctoy_swap_buffer(&image);
	}

#ifdef CRT
	glim_begin();
#endif

	// intro
	ld34_init_intro();
}

void ctoy_main_loop(void)
{
	ld34_update(&image);

#ifdef CRT
	glim_update(&image);
	glim_main_loop();
#else
	ctoy_swap_buffer(&image);
#endif

	//ctoy_sleep(0, 100000);
}

void ctoy_end(void)
{
#ifdef CRT
	glim_end();
#endif

	m_image_destroy(&image);
	ld34_destroy();
}
