
float Log2(float n)
{
    return logf(n) / 0.69314718246459961;  
}

float Round(float d)
{
	return floorf(d + 0.5);
}

float sin_wave(float t)
{
    return sinf(2.0f * M_PI * t);
}

float square_wave(float t)
{
    return sinf(2.0f * M_PI * t) > 0 ? 1 : -1;
}

float saw_wave(float t)
{
    return 2 * (t - floorf(t + 0.5f));
}

float tri_wave(float t)
{
    return 1.0f - 4.0f * fabsf(Round(t - 0.25f) - (t - 0.25f));
}

float noise(float t)
{
    float v = sinf(123523.9898 * t) * 43758.5453;
    return v - floorf(v);
}

void sound1(void)
{
    struct m_image sound = M_IMAGE_IDENTITY();

    float *samples;
    int sample_rate = 44100;
    float freq = 1.0f / sample_rate;
    float seconds = 1.35; //0.65f;
    int frames = seconds * sample_rate;
    int size, i, x;
    
    m_image_create(&sound, M_FLOAT, frames, 1, 2);
    samples = (float *)sound.data;
    size = sound.size;

    for (i = 0, x = 0; i < size; x++) {

        float f = (float)x / (float)(frames - 1);
        float t = freq * x; // in sec
        float v;

        float note_freq = 4.5;

        int in = (int)(t * note_freq);
        float note = (in + 1)*0.125f;
        float offset = in / note_freq;

        v = sin_wave((t - offset) * note*800) * 0.5;
   
        samples[i++] = v * (1-f);
        samples[i++] = v * (1-f);
    }

    m_image_gaussian_blur(&sound, &sound, 16, 0);

    ctoy_sound_stop();
    ctoy_sound_data(samples, size);
    ctoy_sound_looping(0);
    ctoy_sound_play();

    m_image_destroy(&sound);
}

void sound2(void)
{
    struct m_image sound = M_IMAGE_IDENTITY();

    float *samples;
    int sample_rate = 44100;
    float freq = 1.0f / sample_rate;
    float seconds = 1; //0.65f;
    int frames = seconds * sample_rate;
    int size, i, x;
    
    m_image_create(&sound, M_FLOAT, frames, 1, 2);
    samples = (float *)sound.data;
    size = sound.size;

    for (i = 0, x = 0; i < size; x++) {

        float f = (float)x / (float)(frames - 1);
        float t = freq * x; // in sec
        float v;

        float note_freq = 4.5;

        int in = (int)(t * note_freq);
        float note = (in + 1)*0.5f;
        float offset = in / note_freq;

        v = saw_wave(((t - 0) * 0.001) + 1)*1000 * noise(t - offset);

        samples[i++] = v * (1-f)*2;
        samples[i++] = v * (1-f)*2;
    }

    m_image_gaussian_blur(&sound, &sound, 16, 0);

    ctoy_sound_stop();
    ctoy_sound_data(samples, size);
    ctoy_sound_looping(0);
    ctoy_sound_play();

    m_image_destroy(&sound);
}
